
/**
 * This class represents a boy
 * 
 * @author Rastislav Mirek
 */
public class Boy
{
    private String name;
    private Girl girlfriend;
    private int experience;

    /**
     * Constructor for objects of class Boy
     * @param name Name of the boy
     */
    public Boy(String name)
    {
        this.name = name;
        girlfriend = null;
        experience = 0;
    }
    
    /**
     * If given girl is free, this boy is free and given girl wants this boy makes a couple from given girl and this boy
     * @param girl A girl that this boy is trying to pull
     */
    public void pullGirl(Girl girl){
        if(!girl.isTaken() && !isTaken() && girl.wantsBoy(this)){
            girl.setBoyfriend(this);
            girlfriend = girl;
        }
    }
    
    /**
     * splits up with actual girlfriend
     */
    public void splitUp(){
        if(isTaken()){
            girlfriend.setBoyfriend(null);
            girlfriend = null;
            experience = experience + 1;
        }
    }
    
    /**
     * @return number of ex-girlfriends that this boy has had
     */
    public int getExperience(){
        return experience;
    }
    
    public String toString(){
            return "This boy named " + name + " " + getRelationshipStatus() + " and has had " + experience + " exgirlfriends.";
    }
    
    /**
     * help method for <code>toString()</code> method
     * @return string value that tells if the boy is in relationship(with who) or not
     */
    //this method schould be declared private. Hovewer as we haven't spoken about visibility so far, it is declared public here.
    public String getRelationshipStatus(){
        if(!isTaken()){
            return "is free";
        }
        else{
            return "is in relationship with " + girlfriend.toString();
        }
    }
    
    /**
     * @return <code>true</code> if this boy has a girlfriend, <code>false</code> otherwise
     */
    public boolean isTaken(){
        return girlfriend != null;
    }
}
