
/**
 * This class represent a girl.
 * 
 * @author Rastislav Mirek
 */
public class Girl
{
    private String name;
    private Boy boyfriend;
    private int minimalBoyfriendExperience;

    /**
     * Constructor for objects of class Girl
     * @param name Name of the girl
     * @param minimalBoyfriendExperience sets how many exgirlfriends a boy have to have for this girl to by interested in him
     */
    public Girl(String name, int minimalBoyfriendExperience)
    {
       this.name = name;
       this.minimalBoyfriendExperience = minimalBoyfriendExperience;
       boyfriend = null;
    }
    
    /**
     * @return <code>true</code> if girl has a boyfriend, <code>false</code> otherwise
     */
    public boolean isTaken(){
        return boyfriend != null;  //a girl is taken if she has a boyfriend - so the boyfriend is not null
    }
    
    /**
     * sets a boyfriend
     * @param newBoyfiend a new boyfriend of this girl
     */
    public void setBoyfriend(Boy newBoyfriend){
        boyfriend = newBoyfriend;
    }
    
    /**
     * splits up with actual boyfriend
     */
    public void splitUp(){
        if(boyfriend != null){  //if there is no boyfriend actually, there is nothing to do...
            boyfriend.splitUp();
        }
    }
    
    /**
     * @param boy A boy which is to by said wanted or not wanted
     * @return <code>true</code> if this girl wants given boy, <code>false</code> otherwise
     */
    public boolean wantsBoy(Boy boy){
        return boy.getExperience() >= minimalBoyfriendExperience;
    }
    
    public String toString(){
        return "girl named " + name;
    }
}
